def generate_permutations(i, sol, elements):
    # Базовый вариант
    if i == len(elements):
        print_permutations(sol)  # комплексное решение
    else:
        # Генерация элементов-кандидатов
        for k in range(0, len(elements)):

            # Проверка валидности кандидатов
            if not elements[k] in sol[0:i]:

                # Включить кандидата в частное решение
                sol[i] = elements[k]

                # Генерация элемента в позиции i+1
                generate_permutations(i + 1, sol, elements)

                # Удалить кандидата из частного решения
                sol[i] = None  # по желанию


def generate_permutations_wrapper(elements):
    sol = [None] * (len(elements))
    generate_permutations(0, sol, elements)


def print_permutations(sol):
    for i in range(0, len(sol)):
        print(sol[i], ' ', end='')
    print()


generate_permutations_wrapper(['a', 'b', 'c'])
